import 'dotenv/config'

export function getEnv(key: string): string
export function getEnv<T>(key: string, parser: (value: string) => T): T
export function getEnv<T>(key: string, parser?: (value: string) => T): T | string {
  const value = process.env[key]
  if (!value) throw new Error(`env variable ${key} not found`)
  if (!parser) return value
  return parser(value)
}

export function* chunks<T>(arr: T[], size: number) {
  for (let i = 0; i < arr.length; i += size) {
    yield arr.slice(i, i + size)
  }
}
